#include "stdafx.h"
#include "camUntil.h"
#include "camUntilDlg.h"
#include "cameraCtrl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


BEGIN_MESSAGE_MAP(CcamUntilApp, CWinApp)
	ON_COMMAND(ID_HELP, &CWinApp::OnHelp)
END_MESSAGE_MAP()


// CcamUntilApp construction

CcamUntilApp::CcamUntilApp()
{
	// TODO: add construction code here,
	err = EDS_ERR_OK;
	cameraList = NULL;
	camera = NULL;
	count = 0;	
	isSDKLoaded = false;
}


// The one and only CcamUntilApp object

CcamUntilApp theApp;


// CcamUntilApp initialization

BOOL CcamUntilApp::InitInstance()
{
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	err = EdsInitializeSDK();

	if(err == EDS_ERR_OK)
	{
		isSDKLoaded = true;
		err = getFirstCamera (&camera);
		err = EdsSetObjectEventHandler(camera, kEdsObjectEvent_All, handleObjectEvent, NULL);
	}

	// Set event handler
	if(err == EDS_ERR_OK)
	{
		//err = EdsSetPropertyEventHandler(camera, kEdsPropertyEvent_All, handlePropertyEvent, NULL);
	}

	if(err == EDS_ERR_OK)
	{
		err = EdsOpenSession(camera);
	}
	else
		::MessageBox(NULL, _T("Cannot open Session"),NULL,MB_OK);

	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("David Ness Innovations Project, NCCA 2008"));

	CcamUntilDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		EdsTerminateSDK();
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}


EdsCameraRef CcamUntilApp::getCamera()
{
	return camera;
}


