#include "stdafx.h"
#include "camUntil.h"
#include "camUntilDlg.h"
#include "cameraCtrl.h"
#include <time.h>
#include <tchar.h>
#include <math.h>

#include <list>


using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CcamUntilDlg dialog




CcamUntilDlg::CcamUntilDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CcamUntilDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CcamUntilDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_ISO2, m_Iso);

	DDX_Control(pDX, IDC_SHUTTER1, m_cbShutter1);
	DDX_Control(pDX, IDC_SHUTTER2, m_cbShutter2);
	DDX_Control(pDX, IDC_SHUTTER3, m_cbShutter3);
	DDX_Control(pDX, IDC_SHUTTER4, m_cbShutter4);
	DDX_Control(pDX, IDC_SHUTTER5, m_cbShutter5);
	//
	DDX_Control(pDX, IDC_APPER, m_cbApperature);
	DDX_Control(pDX, IDC_WHBAL, m_cbWhiteBallance);
	DDX_Control(pDX, IDC_IMGQUAL, m_cbImageQuality);
	DDX_Control(pDX, IDC_METERMD, m_cbMeterMode);
	//
	DDX_Control(pDX, IDC_OUTPUT, m_outputBox);
	//
	DDX_Control(pDX, IDC_SCHECK1, m_ctrlsCheck1);
	DDX_Control(pDX, IDC_SCHECK2, m_ctrlsCheck2);
	DDX_Control(pDX, IDC_SCHECK3, m_ctrlsCheck3);
	DDX_Control(pDX, IDC_SCHECK4, m_ctrlsCheck4);
	DDX_Control(pDX, IDC_SCHECK5, m_ctrlsCheck5);
	//
	DDX_Control(pDX, IDC_TL_USE, m_TLuse);
	DDX_Text(pDX, IDC_TL_MIN, m_intervalMin);
	DDX_Text(pDX, IDC_TL_SEC, m_intervalSec);
	DDX_Text(pDX, IDC_TL_SHOTNO, m_numShots);
	//
	DDX_Control(pDX, IDC_MODE, m_camMode);
	//
	DDX_Control(pDX, IDC_FL, m_fLenBox);
	DDX_Control(pDX, IDC_IMG_NO, m_imgNum);
	DDX_Control(pDX, IDC_FL_SPIN, m_fLenSpin);
	//
	DDX_Control(pDX, IDC_IMG_NO, m_imgNum);
	//
	DDX_Control(pDX, IDC_STEP, m_step);
}

BEGIN_MESSAGE_MAP(CcamUntilDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	//
	ON_CBN_SELCHANGE(IDC_SHUTTER1, OnSetShutter1)
	ON_CBN_SELCHANGE(IDC_SHUTTER2, OnSetShutter2)
	ON_CBN_SELCHANGE(IDC_SHUTTER3, OnSetShutter3)
	ON_CBN_SELCHANGE(IDC_SHUTTER4, OnSetShutter4)
	ON_CBN_SELCHANGE(IDC_SHUTTER5, OnSetShutter5)
	//
	ON_CBN_SELCHANGE(IDC_APPER, OnSetApperature)
	//
	ON_CBN_SELCHANGE(IDC_WHBAL, OnSetWhiteBallance)
	//
	ON_CBN_SELCHANGE(IDC_IMGQUAL, OnSetImageQuality)
	//
	ON_CBN_SELCHANGE(IDC_METERMD, OnSetMeterMode)
	//
	ON_CBN_SELCHANGE(IDC_ISO2, OnSetIso)
	//
	ON_EN_CHANGE(IDC_STEP, OnStepSize)
	//
	ON_BN_CLICKED(IDC_CAPTURE, Start)
	//
	ON_BN_CLICKED(IDC_SCHECK1, OnsCheck1)
	ON_BN_CLICKED(IDC_SCHECK2, OnsCheck2)
	ON_BN_CLICKED(IDC_SCHECK3, OnsCheck3)
	ON_BN_CLICKED(IDC_SCHECK4, OnsCheck4)
	ON_BN_CLICKED(IDC_SCHECK5, OnsCheck5)

	ON_EN_CHANGE(IDC_FL, OnFLChange)

	ON_BN_CLICKED(IDC_NXT, OnNext)
	ON_BN_CLICKED(IDC_PAUSE, OnPause)
	ON_BN_CLICKED(IDC_PREV, OnPrev)

END_MESSAGE_MAP()


// CcamUntilDlg message handlers

BOOL CcamUntilDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//OpenGL setup
	CRect rect;

	// Get size and position of the template textfield we created before in the dialog editor
	GetDlgItem(IDC_OPENGL)->GetWindowRect(rect);

	// Convert screen coordinates to client coordinates
	ScreenToClient(rect);

	// Create OpenGL Control window
	m_oglWindow.oglCreate(rect, this);

	// Setup the OpenGL Window's timer to render
	m_oglWindow.m_unpTimer = m_oglWindow.SetTimer(1, 1, 0);
		m_oglWindow.SetFocus();

	//Set up defaults for when the app opens and set the camera too those defaults
	m_cbApperature.SetCurSel(4);
	setAv(theApp.getCamera(), 4);

	m_cbWhiteBallance.SetCurSel(0);
	setWhiteBallance(theApp.getCamera(), 0);

	m_cbImageQuality.SetCurSel(4);
	setImageQuality(theApp.getCamera(), 4);

	m_cbMeterMode.SetCurSel(0);
	setMeterMode(theApp.getCamera(), 0);

	m_Iso.SetCurSel(0);
	setISO(theApp.getCamera(), 0);

	m_cbShutter1.SetCurSel(29);
	TvValS1 = 0x5D;

	m_cbShutter2.SetCurSel(30);
	TvValS2 = 0x60;

	m_cbShutter3.SetCurSel(31);
	TvValS3 = 0x63;

	m_cbShutter4.SetCurSel(32);
	TvValS4 = 0x64;

	m_cbShutter5.SetCurSel(33);
	TvValS5 = 0x68;

	outMessage(_T("Initalized Application..."));

	OnAEMode();
	
	m_sCheck1 = false;
	m_sCheck2 = false;
	m_sCheck3 = false;
	m_sCheck4 = false;
	m_sCheck5 = false;

	m_cbShutter1.EnableWindow(0);
	m_cbShutter2.EnableWindow(0);
	m_cbShutter3.EnableWindow(1);
	m_cbShutter4.EnableWindow(0);
	m_cbShutter5.EnableWindow(0);


	m_fLenBox.SetWindowTextW(_T("18"));
	m_imgNum.SetWindowTextW(_T("12"));
	m_step.SetWindowTextW(_T("2"));

	delay = 1;

	initControls();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CcamUntilDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CcamUntilDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CcamUntilDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CcamUntilDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);
    
	switch (nType)
	{
		case SIZE_RESTORED:
		{
			if (m_oglWindow.m_bIsMaximized)
			{
				m_oglWindow.OnSize(nType, cx, cy);
				m_oglWindow.m_bIsMaximized = false;
			}

			break;
		}

		case SIZE_MAXIMIZED:
		{
			m_oglWindow.OnSize(nType, cx, cy);
			m_oglWindow.m_bIsMaximized = true;

			break;
		}
	}
}

BOOL CcamUntilDlg::PreTranslateMessage(MSG* pMsg) 
{
	switch (pMsg->message)
	{
		case WM_KEYUP:
			//m_oglWindow.currFrame++;
			break;
		
		case WM_KEYDOWN:
			break;
	}
	return CWnd::PreTranslateMessage(pMsg);
}

void CcamUntilDlg::initControls()
{
	if(theApp.err != EDS_ERR_OK)
	{
		m_cbApperature.EnableWindow(0);
		m_cbWhiteBallance.EnableWindow(0);
		m_cbImageQuality.EnableWindow(0);
		m_cbMeterMode.EnableWindow(0);
		m_Iso.EnableWindow(0);

		m_ctrlsCheck1.EnableWindow(0); 
		m_ctrlsCheck2.EnableWindow(0);
		m_ctrlsCheck4.EnableWindow(0); 
		m_ctrlsCheck5.EnableWindow(0);

		m_step.EnableWindow(0);
	}
}


void CcamUntilDlg::OnSetShutter1()
{
	int shutterIndex = m_cbShutter1.GetCurSel();
	TvValS1 = getTvVal(shutterIndex);
}


void CcamUntilDlg::OnSetShutter2()
{
	int shutterIndex = m_cbShutter2.GetCurSel();
	TvValS2 = getTvVal(shutterIndex);
}


void CcamUntilDlg::OnSetShutter3()
{
	int shutterIndex = m_cbShutter3.GetCurSel();
	TvValS3 = getTvVal(shutterIndex);
	setTv(theApp.getCamera(), TvValS3);

	int stepSize = m_oglWindow.stepVal;

	m_cbShutter1.SetCurSel(shutterIndex + (stepSize*2));
	m_cbShutter2.SetCurSel(shutterIndex + (stepSize));
	m_cbShutter4.SetCurSel(shutterIndex - (stepSize));
	m_cbShutter5.SetCurSel(shutterIndex - (stepSize*2));
}


void CcamUntilDlg::OnSetShutter4()
{
	int shutterIndex = m_cbShutter4.GetCurSel();
	TvValS4 = getTvVal(shutterIndex);
}


void CcamUntilDlg::OnSetShutter5()
{
	int shutterIndex = m_cbShutter5.GetCurSel();
	TvValS5 = getTvVal(shutterIndex);
}


void CcamUntilDlg::OnSetApperature()
{
	int apperatureIndex = m_cbApperature.GetCurSel();
	int apperatureVal =0x30;

	switch (apperatureIndex)
	{
		case 0: apperatureVal = 0x24; break;  // 3.5
		case 1: apperatureVal = 0x28; break;  // 4.0
		case 2: apperatureVal = 0x2B; break;  // 4.5
		case 3: apperatureVal = 0x30; break;  // 5.0 // cam doesn't suport so make 5.6
		case 4: apperatureVal = 0x30; break;  // 5.6
		case 5: apperatureVal = 0x33; break;  // 6.3
		case 6: apperatureVal = 0x35; break;  // 7.1
		case 7: apperatureVal = 0x38; break;  // 8.0
		case 8: apperatureVal = 0x3B; break;  // 9.0
		case 9: apperatureVal = 0x3D; break;  // 10
		case 10: apperatureVal = 0x40; break; // 11
		case 11: apperatureVal = 0x44; break; // 13
		case 12: apperatureVal = 0x45; break; // 14
		case 13: apperatureVal = 0x48; break; // 16
		case 14: apperatureVal = 0x4B; break; // 18
		case 15: apperatureVal = 0x4D; break; // 20
		case 16: apperatureVal = 0x50; break; // 22
		case 17: apperatureVal = 0x53; break; // 25
		case 18: apperatureVal = 0x55; break; // 29
		case 19: apperatureVal = 0x58; break; // 32
		case 20: apperatureVal = 0x5B; break; // 36
	}

	setAv(theApp.getCamera(), apperatureVal);
}


void CcamUntilDlg::OnSetWhiteBallance()
{
	int whiteBallanceIndex = m_cbWhiteBallance.GetCurSel();
	int whiteBallanceVal;

	switch (whiteBallanceIndex)
	{
		case 0: whiteBallanceVal = 0; break;  // Auto
		case 1: whiteBallanceVal = 1; break;  // Daylight
		case 2: whiteBallanceVal = 8; break;  // Shade
		case 3: whiteBallanceVal = 2; break;  // Cloudy
		case 4: whiteBallanceVal = 3; break;  // Tungsten
		case 5: whiteBallanceVal = 4; break;  // White Flourencent
		case 6: whiteBallanceVal = 5; break;  // Flash
		case 7: whiteBallanceVal = 6; break;  // Custom
	}

	setWhiteBallance(theApp.getCamera(), whiteBallanceVal);
}


void CcamUntilDlg::OnSetImageQuality()
{
	int imageQualityIndex = m_cbImageQuality.GetCurSel();
	int imageQualityVal;

	switch (imageQualityIndex)
	{
		case 0: imageQualityVal = 0x02120000; break;  // Small Normal
		case 1: imageQualityVal = 0x02130000; break;  // Small Fine
		case 2: imageQualityVal = 0x01120000; break;  // Medium Normal
		case 3: imageQualityVal = 0x01130000; break;  // Medium Fine
		case 4: imageQualityVal = 0x00120000; break;  // Large Normal
		case 5: imageQualityVal = 0x00130000; break;  // Large Fine
		case 6: imageQualityVal = 0x00640013; break;  // Large RAW
		case 7: imageQualityVal = 0x00640f0f; break;  // RAW
	}

	setImageQuality(theApp.getCamera(), imageQualityVal);
}


void CcamUntilDlg::OnSetMeterMode()
{
	int meterModeIndex = m_cbMeterMode.GetCurSel();
	int meterModeVal;

	switch (meterModeIndex)
	{
		case 0: meterModeVal = 3; break;  // Evaluative
		case 1: meterModeVal = 4; break;  // Partial
		case 2: meterModeVal = 5; break;  // Center Weighted
	}
	setMeterMode(theApp.getCamera(), meterModeVal);
}

void CcamUntilDlg::OnSetIso()
{
	int isoIndex = m_Iso.GetCurSel();
	int isoVal;

	switch (isoIndex)
	{
		case 0: isoVal = 0x00000048; break;  // 100
		case 1: isoVal = 0x00000050; break;  // 200
		case 2: isoVal = 0x00000058; break;  // 400
		case 3: isoVal = 0x00000060; break;  // 800
		case 4: isoVal = 0x00000068; break;  // 1600
	}

	setISO(theApp.getCamera(), isoVal);
}


void CcamUntilDlg::OnCapture()
{
	EdsCameraRef camera =  theApp.getCamera();
	EdsError err = EDS_ERR_OK;

	int numPics = m_oglWindow.numPics;

	for(int i =0; i <2; i++)
	{

		if(m_ctrlsCheck1.GetCheck())
		{
			setTv(camera, TvValS1);
			err = takePicture(camera);
			OnDelay(2);
			if(err == EDS_ERR_OK)
				outMessage(_T("Picture -2 Taken..."));
			else
				outMessage(_T("Failed to take picture -2..."));
		}

		OnDelay(delay);

		if(m_ctrlsCheck2.GetCheck())
		{
			setTv(camera, TvValS2);
			err = takePicture(camera);
			OnDelay(2);

			if(err == EDS_ERR_OK)
				outMessage(_T("Picture -1 Taken..."));
			else
				outMessage(_T("Failed to take picture -1..."));
		}

		OnDelay(delay);

		if(m_ctrlsCheck3.GetCheck())
		{
			setTv(camera, TvValS3);
			err = takePicture(camera);


			if(err == EDS_ERR_OK)
				outMessage(_T("Base Picture Taken..."));
			else
				outMessage(_T("Failed to take base picture..."));
		}

		OnDelay(delay);

		if(m_ctrlsCheck4.GetCheck())
		{
			setTv(camera, TvValS4);
			err = takePicture(camera);

			if(err == EDS_ERR_OK)
				outMessage(_T("Picture +1 Taken..."));
			else
				outMessage(_T("Failed to take picture +1..."));
		}

		OnDelay(delay);

		if(m_ctrlsCheck5.GetCheck())
		{
			setTv(camera, TvValS5);
			err = takePicture(camera);

			if(err == EDS_ERR_OK)
				outMessage(_T("Picture +2 Taken..."));
			else
				outMessage(_T("Failed to take picture +2..."));
		}
		m_oglWindow.currFrame++;
	}
	
}

void CcamUntilDlg::Start()
{
	// if time lapse check box is not enabled just do once...
	if(!m_TLuse.GetCheck())
	{
		OnCapture();
	}
	else // if time lapse is enabled fall into this...
	{
		UpdateData();
		
		double maxShots = _ttoi(m_numShots);
		int tlMins =	_ttoi(m_intervalMin);
		int tlSecs =	_ttoi(m_intervalSec);
		int totalSecs = (int)((tlMins * 60) + tlSecs);

		for(double i=0; i <= maxShots; i++)
		{

		}
		exit(111);
	}
}

void CcamUntilDlg::outMessage(CString inText)
{
	inText.Append(_T("\r\n"));
	int size = (int)outTextVec.size();

	if(size > 10)
	{
		//pop one off the vector
		//outTextVec.pop_front();

		//push one onto the vector
		//outTextVec.push_back(inText);
	}
	else
	{
		//push one onto the vector
		outTextVec.push_back(inText);
	}

	testString.Empty();

	for(list<CString>::iterator it = outTextVec.begin(); it != outTextVec.end(); it++)
	{
		testString.Append(*it);
	}
	m_outputBox.SetWindowText(testString);
}

void CcamUntilDlg::OnDelay(int val)
{
	time_t start_time, cur_time;

	time(&start_time);
	do
	{
		time(&cur_time);
	}
	while((cur_time - start_time) < val);
}

int CcamUntilDlg::getTvVal(int index)
{
	int shutterVal = 0;

	switch (index)
	{
		case 0: shutterVal = 0x10; break;  // 30"
		case 1: shutterVal = 0x13; break;  // 25"
		case 2: shutterVal = 0x14; break;  // 20"
		case 3: shutterVal = 0x18; break;  // 15"
		case 4: shutterVal = 0x1B; break;  // 13"
		case 5: shutterVal = 0x1C; break;  // 10"
		case 6: shutterVal = 0x20; break;  // 8"
		case 7: shutterVal = 0x24; break;  // 6"
		case 8: shutterVal = 0x25; break;  // 5"
		case 9: shutterVal = 0x28; break;  // 4"
		case 10: shutterVal = 0x2B; break; // 3"2
		case 11: shutterVal = 0x2D; break; // 2"5
		case 12: shutterVal = 0x20; break; // 2"
		case 13: shutterVal = 0x33; break; // 1"6
		case 14: shutterVal = 0x35; break; // 1"3
		case 15: shutterVal = 0x38; break; // 1"
		case 16: shutterVal = 0x3B; break; // 0"8
		case 17: shutterVal = 0x3D; break; // 0"6
		case 18: shutterVal = 0x40; break; // 0"5
		case 19: shutterVal = 0x43; break; // 0"4
		case 20: shutterVal = 0x44; break; // 0"3
		case 21: shutterVal = 0x48; break; // 1/4 
		case 22: shutterVal = 0x4B; break; // 1/5
		case 23: shutterVal = 0x4C; break; // 1/6
		case 24: shutterVal = 0x50; break; // 1/8
		case 25: shutterVal = 0x53; break; // 1/10
		case 26: shutterVal = 0x55; break; // 1/13
		case 27: shutterVal = 0x58; break; // 1/15
		case 28: shutterVal = 0x5B; break; // 1/20
		case 29: shutterVal = 0x5D; break; // 1/25
		case 30: shutterVal = 0x60; break; // 1/30
		case 31: shutterVal = 0x63; break; // 1/40
		case 32: shutterVal = 0x64; break; // 1/50
		case 33: shutterVal = 0x68; break; // 1/60
		case 34: shutterVal = 0x6B; break; // 1/80
		case 35: shutterVal = 0x6D; break; // 1/100 
		case 36: shutterVal = 0x70; break; // 1/125
		case 37: shutterVal = 0x73; break; // 1/160
		case 38: shutterVal = 0x75; break; // 1/200
		case 39: shutterVal = 0x78; break; // 1/250
		case 40: shutterVal = 0x7B; break; // 1/320
		case 41: shutterVal = 0x7D; break; // 1/400
		case 42: shutterVal = 0x80; break; // 1/500
		case 43: shutterVal = 0x83; break; // 1/640
		case 44: shutterVal = 0x85; break; // 1/800
		case 45: shutterVal = 0x88; break; // 1/1000
		case 46: shutterVal = 0x8B; break; // 1/1250
		case 47: shutterVal = 0x8D; break; // 1/1600
		case 48: shutterVal = 0x90; break; // 1/2000
		case 49: shutterVal = 0x93; break; // 1/2500
		case 50: shutterVal = 0x95; break; // 1/3200
		case 51: shutterVal = 0x98; break; // 1/4000

	}
	return shutterVal;

}


void CcamUntilDlg::OnAEMode()
{	
	EdsPropertyDesc mode;

	getAEMode(theApp.getCamera(), &mode);

	switch(mode.form)
	{
	case 0:
		m_camMode.SetWindowTextW(_T("Apper. Priority")); break;
	case 1:
		m_camMode.SetWindowTextW(_T("Shutter Prority")); break;
	case 3:
		m_camMode.SetWindowTextW(_T("(Manual Mode")); break;
	case 4:
		m_camMode.SetWindowTextW(_T("BULB Mode")); break;
	case 5:
		m_camMode.SetWindowTextW(_T("Auto Depth-of-Field")); break;
	case 6:
		m_camMode.SetWindowTextW(_T("Depth-of-Field")); break;
	case 7:
		m_camMode.SetWindowTextW(_T("Auto Depth-of-Field")); break;
	case 9:
		m_camMode.SetWindowTextW(_T("Auto"));
		MessageBox(_T("This program is used to set camera values,\n therefore it should be in a manual mode. \n Please restart the camera in an appropriate mode"));
		break;
	case 10:
		m_camMode.SetWindowTextW(_T("Night")); break;
	case 11:
		m_camMode.SetWindowTextW(_T("Sports")); break;
	case 12:
		m_camMode.SetWindowTextW(_T("Portrait")); break;
	case 13:
		m_camMode.SetWindowTextW(_T("Landscape")); break;
	case 14:
		m_camMode.SetWindowTextW(_T("CloseUp")); break;

	default:
		m_camMode.SetWindowTextW(_T("n/a")); 
		outMessage(_T("Error: Could not detect camera mode"));
		break;
	}
}

void CcamUntilDlg::OnsCheck1()
{
	m_sCheck1 = !m_sCheck1;
	m_cbShutter1.EnableWindow(m_sCheck1);
}

void CcamUntilDlg::OnsCheck2()
{
	m_sCheck2 = !m_sCheck2;
	m_cbShutter2.EnableWindow(m_sCheck2);
}

void CcamUntilDlg::OnsCheck3()
{
	m_sCheck3 = !m_sCheck3;
	m_cbShutter3.EnableWindow(m_sCheck3);
}

void CcamUntilDlg::OnsCheck4()
{
	m_sCheck4 = !m_sCheck4;
	m_cbShutter4.EnableWindow(m_sCheck4);
}

void CcamUntilDlg::OnsCheck5()
{
	m_sCheck5 = !m_sCheck5;
	m_cbShutter5.EnableWindow(m_sCheck5);
}

void CcamUntilDlg::OnNext()
{
	m_oglWindow.nextFrame();
}

void CcamUntilDlg::OnPause()
{
}

void CcamUntilDlg::OnPrev()
{
	m_oglWindow.previousFrame();
}

void CcamUntilDlg::OnStepSize()
{
	m_step.GetWindowTextW(e_step);
	
	m_oglWindow.stepVal = _ttoi(e_step);
}

void CcamUntilDlg::OnFLChange()
{
	m_fLenBox.GetWindowTextW(e_fLenBox);

	m_oglWindow.focalLength = _ttoi(e_fLenBox);

	int f = m_oglWindow.focalLength;

	float angle = atan((22.2 * 0.5) / (float)f);
	angle = angle *(180 / 3.1468);
	angle -= angle*m_oglWindow.overlap;

	m_oglWindow.numPics = (int)(360 / angle);

	testString.Format(_T("%d"), m_oglWindow.numPics);

	m_imgNum.SetWindowTextW(testString);

	UpdateData();
}



/*static EdsError EDSCALLBACK  handlePropertyEvent (
						EdsUInt32			inEvent,
						EdsUInt32			inPropertyID,
						EdsUInt32			inParam, 
						EdsVoid *			inContext				
						)
{

}
*/
