//camUntil.h
//Contains variable definitions for use in the main dialog window

#pragma once

#include <list>
#include "EDSDKTypes.h"
#include "oglInterface.h"

// CcamUntilDlg dialog
class CcamUntilDlg : public CDialog
{
// Construction
public:
	CcamUntilDlg(CWnd* pParent = NULL);	// standard constructor

private:
		oglInterface m_oglWindow;

// Dialog Data
	enum { IDD = IDD_CAMUNTIL_DIALOG };

	CComboBox  m_cbShutter1;
	CComboBox  m_cbShutter2;
	CComboBox  m_cbShutter3;
	CComboBox  m_cbShutter4;
	CComboBox  m_cbShutter5;

	CComboBox  m_cbApperature;
	CComboBox  m_cbWhiteBallance;
	CComboBox  m_cbImageQuality;
	CComboBox  m_cbMeterMode;

	CEdit  m_fLenBox;
	CString  e_fLenBox;
	CEdit  m_imgNum;
	CSpinButtonCtrl m_fLenSpin;

	CComboBox m_Iso;

	CString	   testString;
	CEdit	   m_outputBox;

	CButton m_ctrlsCheck1, m_ctrlsCheck2, m_ctrlsCheck3, m_ctrlsCheck4, m_ctrlsCheck5;
	BOOL m_sCheck1, m_sCheck2, m_sCheck3, m_sCheck4, m_sCheck5;

	int TvValS1, TvValS2, TvValS3, TvValS4, TvValS5;

	CButton	   m_TLuse;

	CString	   m_intervalMin;
	CString	   m_intervalSec;
	CString	   m_numShots;

	CEdit    m_camMode;

	CString e_step;
	CEdit m_step;

	int delay;

	std::list<CString>   outTextVec;

	static EdsError EDSCALLBACK  handlePropertyEvent (
					EdsUInt32			inEvent,
					EdsUInt32			inPropertyID,
					EdsUInt32			inParam, 
					EdsVoid *			inContext				
					);

protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	int getTvVal(int index);
	void OnDelay(int val);
	void outMessage(CString inText);
	void initControls();




// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg HCURSOR OnQueryDragIcon();
	BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnSetShutter1();
	afx_msg void OnSetShutter2();
	afx_msg void OnSetShutter3();
	afx_msg void OnSetShutter4();
	afx_msg void OnSetShutter5();
	//
	afx_msg void OnSetApperature();
	//
	afx_msg void OnSetImageQuality();
	//
	afx_msg void OnSetWhiteBallance();
	//
	afx_msg void OnSetMeterMode();
	//
	afx_msg void OnCapture();
	afx_msg void Start();
	//
	afx_msg void OnSetIso();
	//
	afx_msg void OnsCheck1();
	afx_msg void OnsCheck2();
	afx_msg void OnsCheck3();
	afx_msg void OnsCheck4();
	afx_msg void OnsCheck5();
	//
	afx_msg void OnNext();
	afx_msg void OnPause();
	afx_msg void OnPrev();
	//
	afx_msg void OnAEMode();
	//
	afx_msg void OnSetFocalLen();
	afx_msg void OnStepSize();
	afx_msg void OnFLChange();

	DECLARE_MESSAGE_MAP()
};
