//cameraCtrl.h
//This file (.h and .cpp) contains functionality for comunicating with the camera via the Canon SDK
//
#pragma once

#include "EDSDK.h"
#include "EDSDKTypes.h"
#include "EDSDKErrors.h"

EdsError getFirstCamera(EdsCameraRef *camera);

EdsError EDSCALLBACK handleSateEvent (EdsPropertyEvent event, EdsPropertyID property, EdsVoid * context);
EdsError EDSCALLBACK handleObjectEvent( EdsObjectEvent event, EdsBaseRef object, EdsVoid * context);
EdsError EDSCALLBACK handlePropertyEvent (EdsPropertyEvent event, EdsPropertyID property, EdsVoid * context);
EdsError takePicture(EdsCameraRef camera);

EdsError downloadImage(EdsDirectoryItemRef directoryItem);

EdsError setTv(EdsCameraRef camera, EdsUInt32 TvValue);
EdsError setAv(EdsCameraRef camera, EdsUInt32 AvValue);
EdsError setISO(EdsCameraRef camera, EdsUInt32 IsoValue);
EdsError setImageQuality(EdsCameraRef camera, EdsUInt32 imgQualVal);
EdsError setWhiteBallance(EdsCameraRef camera, EdsUInt32 whiteBallanceVal);
EdsError setMeterMode(EdsCameraRef camera, EdsUInt32 meterModeVal);

EdsError getAEMode(EdsCameraRef camera, EdsPropertyDesc *AEMode);

EdsError setStateEventHandler();
