//oglInterface.h
//Contains class definitions 

#pragma once
#include "afxwin.h"
#include <fstream>

#include <GL/gl.h>
#include <GL/glu.h>

using namespace std;

class oglInterface : public CWnd
{
	public:
		/******************/
		/* Public Members */
		/******************/
		UINT_PTR m_unpTimer;
		// View information variables
		float	 m_lastX;
		float	 m_lastY;
		float	 m_posX;
		float	 m_posY;
		float	 m_zoom;
		float	 m_rotX;
		float	 m_rotY;
		bool	 m_bIsMaximized;

		int currFrame;
		int numPics;
		float width;
		float height;
		int stepVal;
		int focalLength;
		float overlap;

		fstream outFile;

	private:
		/*******************/
		/* Private Members */
		/*******************/
		// Window information
		CWnd  *hWnd;
		HDC   hdc;			
		HGLRC hrc;			
		int   m_nPixelFormat;
		CRect m_rect;
		CRect m_oldWindow;
		CRect m_originalRect;

	public:
		oglInterface(void);
		virtual ~oglInterface(void);

		void oglCreate(CRect rect, CWnd *parent);
		void oglInitialize(void);
		void oglDrawScene(void);
		BOOL PreTranslateMessage(MSG* pMsg);
		
		void previousFrame();
		void nextFrame();

		// Added message classes:
		afx_msg void OnPaint();
		afx_msg void OnSize(UINT nType, int cx, int cy);
		afx_msg	void OnDraw(CDC *pDC);
		afx_msg int  OnCreate(LPCREATESTRUCT lpCreateStruct);
		afx_msg void OnTimer(UINT nIDEvent);
		afx_msg void OnMouseMove(UINT nFlags, CPoint point);
		afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt,UINT nFlags );

		DECLARE_MESSAGE_MAP()
};